// softpot.ino
//
// 触れた位置を測る（SoftPot使用）
// 
// Written by Nobuki HIRAMINE
// Last modified : 2011/12/03

#include <LiquidCrystal.h>

#define SENSORPIN	(0)
#define VALUE_1		(170)
#define POSITION_1	(20.0)
#define VALUE_2		(440)
#define POSITION_2	(50.0)

LiquidCrystal lcd(12, 11, 5, 4, 3, 2 );

void setup()
{
	lcd.begin(16, 2);
	lcd.clear();
}

double Map( int iIn, int iIn1, int iIn2, double dOut1, double dOut2, boolean bConstrain = false )
{
	double dValue = (iIn - iIn1) * (dOut2 - dOut1) / (iIn2 - iIn1) + dOut1;
	if( bConstrain )
	{
		double dOutMin, dOutMax;
		if( dOut1 < dOut2 )
		{
			dOutMin= dOut1;
			dOutMax= dOut2;
		}
		else
		{
			dOutMin= dOut2;
			dOutMax= dOut1;
		}
		if( dOutMin > dValue )
		{
			return dOutMin;
		}
		if( dOutMax < dValue )
		{
			return dOutMax;
		}
	}
	return dValue;
}

void loop()
{
	int iValue = analogRead( SENSORPIN );
	
	double dPosition = Map( iValue, VALUE_1, VALUE_2, POSITION_1, POSITION_2, false );
	
	lcd.clear();
	lcd.setCursor( 0, 0 );
	lcd.print( "iValue : " );
	lcd.print( iValue );
	lcd.setCursor( 0, 1 );
	if( 0 == iValue )
	{
		lcd.print("OFF");
	}
	else
	{
		lcd.print( dPosition );
		lcd.print( "[mm]" );
	}
	
	delay(1000);
}
